SDL_cpuinfo.h File Reference
`#include "SDL_stdinc.h"`
`#include <immintrin.h>`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_cpuinfo.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_CACHELINE_SIZE 128

## Functions

int | SDL_GetCPUCount (void)
int | SDL_GetCPUCacheLineSize (void)
SDL_bool | SDL_HasRDTSC (void)
SDL_bool | SDL_HasAltiVec (void)
SDL_bool | SDL_HasMMX (void)
SDL_bool | SDL_Has3DNow (void)
SDL_bool | SDL_HasSSE (void)
SDL_bool | SDL_HasSSE2 (void)
SDL_bool | SDL_HasSSE3 (void)
SDL_bool | SDL_HasSSE41 (void)
SDL_bool | SDL_HasSSE42 (void)
SDL_bool | SDL_HasAVX (void)
SDL_bool | SDL_HasAVX2 (void)
SDL_bool | SDL_HasAVX512F (void)
SDL_bool | SDL_HasNEON (void)
int | SDL_GetSystemRAM (void)
size_t | SDL_SIMDGetAlignment (void)
| Report the alignment this system needs for SIMD allocations. More...
void * | SDL_SIMDAlloc (const size_t len)
| Allocate memory in a SIMD-friendly way. More...
void | SDL_SIMDFree (void *ptr)
| Deallocate memory obtained from SDL_SIMDAlloc. More...

## Detailed Description

CPU feature detection for SDL.

Definition in file SDL_cpuinfo.h.

## Macro Definition Documentation

## SDL_CACHELINE_SIZE

#define SDL_CACHELINE_SIZE 128

Definition at line 114 of file SDL_cpuinfo.h.

## Function Documentation

## SDL_GetCPUCacheLineSize()

int SDL_GetCPUCacheLineSize | ( | void |  | ) |

This function returns the L1 cache line size of the CPU

This is useful for determining multi-threaded structure padding or SIMD prefetch sizes.

Definition at line 133 of file SDL_dynapi_procs.h.

References cpuid, d, SDL_CACHELINE_SIZE, SDL_GetCPUType(), SDL_strcmp, and void.

## SDL_GetCPUCount()

int SDL_GetCPUCount | ( | void |  | ) |

This function returns the number of CPU cores available.

Definition at line 447 of file SDL_cpuinfo.c.

{
if (!SDL_CPUCount) {
#ifndef SDL_CPUINFO_DISABLED
#if defined(HAVE_SYSCONF) && defined(_SC_NPROCESSORS_ONLN)
if (SDL_CPUCount <= 0) {
SDL_CPUCount = (int)sysconf(_SC_NPROCESSORS_ONLN);
}
#endif
#ifdef HAVE_SYSCTLBYNAME
if (SDL_CPUCount <= 0) {
size_t size = sizeof(SDL_CPUCount);
sysctlbyname("hw.ncpu", &SDL_CPUCount, &size, NULL, 0);
}
#endif
#ifdef __WIN32__
if (SDL_CPUCount <= 0) {
SYSTEM_INFO info;
GetSystemInfo(&info);
SDL_CPUCount = info.dwNumberOfProcessors;
}
#endif
#ifdef __OS2__
if (SDL_CPUCount <= 0) {
DosQuerySysInfo(QSV_NUMPROCESSORS, QSV_NUMPROCESSORS,
&SDL_CPUCount, sizeof(SDL_CPUCount) );
}
#endif
#endif
/* There has to be at least 1, right? :) */
if (SDL_CPUCount <= 0) {
SDL_CPUCount = 1;
}
}
return SDL_CPUCount;
}

References NULL, and SDL_CPUCount.

## SDL_GetSystemRAM()

int SDL_GetSystemRAM | ( | void |  | ) |

This function returns the amount of RAM configured in the system, in MB.

Definition at line 143 of file SDL_dynapi_procs.h.

References NULL, and SDL_SystemRAM.

## SDL_Has3DNow()

SDL_bool SDL_Has3DNow | ( | void |  | ) |

This function returns true if the CPU has 3DNow! features.

Definition at line 137 of file SDL_dynapi_procs.h.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_3DNOW.

## SDL_HasAltiVec()

SDL_bool SDL_HasAltiVec | ( | void |  | ) |

This function returns true if the CPU has AltiVec features.

Definition at line 135 of file SDL_dynapi_procs.h.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_ALTIVEC.

## SDL_HasAVX()

SDL_bool SDL_HasAVX | ( | void |  | ) |

This function returns true if the CPU has AVX features.

Definition at line 599 of file SDL_dynapi_procs.h.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_AVX.

## SDL_HasAVX2()

SDL_bool SDL_HasAVX2 | ( | void |  | ) |

This function returns true if the CPU has AVX2 features.

Definition at line 741 of file SDL_cpuinfo.c.

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_AVX2);
}

References CPU_FEATURE_AVAILABLE, and CPU_HAS_AVX2.

## SDL_HasAVX512F()

SDL_bool SDL_HasAVX512F | ( | void |  | ) |

This function returns true if the CPU has AVX-512F (foundation) features.

Definition at line 747 of file SDL_cpuinfo.c.

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_AVX512F);
}

References CPU_FEATURE_AVAILABLE, and CPU_HAS_AVX512F.

## SDL_HasMMX()

SDL_bool SDL_HasMMX | ( | void |  | ) |

This function returns true if the CPU has MMX features.

Definition at line 693 of file SDL_cpuinfo.c.

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_MMX);
}

References CPU_FEATURE_AVAILABLE, and CPU_HAS_MMX.

## SDL_HasNEON()

SDL_bool SDL_HasNEON | ( | void |  | ) |

This function returns true if the CPU has NEON (ARM SIMD) features.

Definition at line 652 of file SDL_dynapi_procs.h.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_NEON.

## SDL_HasRDTSC()

SDL_bool SDL_HasRDTSC | ( | void |  | ) |

This function returns true if the CPU has the RDTSC instruction.

Definition at line 681 of file SDL_cpuinfo.c.

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_RDTSC);
}

References CPU_FEATURE_AVAILABLE, and CPU_HAS_RDTSC.

## SDL_HasSSE()

SDL_bool SDL_HasSSE | ( | void |  | ) |

This function returns true if the CPU has SSE features.

Definition at line 705 of file SDL_cpuinfo.c.

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE);
}

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE.

## SDL_HasSSE2()

SDL_bool SDL_HasSSE2 | ( | void |  | ) |

This function returns true if the CPU has SSE2 features.

Definition at line 139 of file SDL_dynapi_procs.h.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE2.

## SDL_HasSSE3()

SDL_bool SDL_HasSSE3 | ( | void |  | ) |

This function returns true if the CPU has SSE3 features.

Definition at line 717 of file SDL_cpuinfo.c.

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE3);
}

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE3.

## SDL_HasSSE41()

SDL_bool SDL_HasSSE41 | ( | void |  | ) |

This function returns true if the CPU has SSE4.1 features.

Definition at line 141 of file SDL_dynapi_procs.h.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE41.

## SDL_HasSSE42()

SDL_bool SDL_HasSSE42 | ( | void |  | ) |

This function returns true if the CPU has SSE4.2 features.

Definition at line 729 of file SDL_cpuinfo.c.

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE42);
}

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE42.

## SDL_SIMDAlloc()

void* SDL_SIMDAlloc | ( | const size_t | len | ) |

Allocate memory in a SIMD-friendly way.

This will allocate a block of memory that is suitable for use with SIMD instructions. Specifically, it will be properly aligned and padded for the system's supported vector instructions.

The memory returned will be padded such that it is safe to read or write an incomplete vector at the end of the memory block. This can be useful so you don't have to drop back to a scalar fallback at the end of your SIMD processing loop to deal with the final elements without overflowing the allocated buffer.

You must free this memory with SDL_FreeSIMD(), not free() or SDL_free() or delete[], etc.

Note that SDL will only deal with SIMD instruction sets it is aware of; for example, SDL 2.0.8 knows that SSE wants 16-byte vectors (SDL_HasSSE()), and AVX2 wants 32 bytes (SDL_HasAVX2()), but doesn't know that AVX-512 wants 64. To be clear: if you can't decide to use an instruction set with an SDL_Has*() function, don't use that instruction set with memory allocated through here.

SDL_AllocSIMD(0) will return a non-NULL pointer, assuming the system isn't out of memory.

Parameters

  len | The length, in bytes, of the block to allocated. The actual allocated block might be larger due to padding, etc.

Returns
  Pointer to newly-allocated block, NULL if out of memory.

See also
  SDL_SIMDAlignment
  SDL_SIMDFree

Definition at line 823 of file SDL_cpuinfo.c.

{
const size_t alignment = SDL_SIMDGetAlignment();
const size_t padding = alignment - (len % alignment);
const size_t padded = (padding != alignment) ? (len + padding) : len;
Uint8 *retval = NULL;
Uint8 *ptr = (Uint8 *) SDL_malloc(padded + alignment + sizeof (void *));
if (ptr) {
/* store the actual malloc pointer right before our aligned pointer. */
retval = ptr + sizeof (void *);
retval += alignment - (((size_t) retval) % alignment);
*(((void **) retval) - 1) = ptr;
}
return retval;
}

References NULL, retval, SDL_malloc, and SDL_SIMDGetAlignment().

## SDL_SIMDFree()

void SDL_SIMDFree | ( | void * | ptr | ) |

Deallocate memory obtained from SDL_SIMDAlloc.

It is not valid to use this function on a pointer from anything but SDL_SIMDAlloc(). It can't be used on pointers from malloc, realloc, SDL_malloc, memalign, new[], etc.

However, SDL_SIMDFree(NULL) is a legal no-op.

See also
  SDL_SIMDAlloc

Definition at line 840 of file SDL_cpuinfo.c.

{
if (ptr) {
void **realptr = (void **) ptr;
realptr--;
SDL_free(*(((void **) ptr) - 1));
}
}

References SDL_free.

## SDL_SIMDGetAlignment()

size_t SDL_SIMDGetAlignment | ( | void |  | ) |

Report the alignment this system needs for SIMD allocations.

This will return the minimum number of bytes to which a pointer must be aligned to be compatible with SIMD instructions on the current machine. For example, if the machine supports SSE only, it will return 16, but if it supports AVX-512F, it'll return 64 (etc). This only reports values for instruction sets SDL knows about, so if your SDL build doesn't have SDL_HasAVX512F(), then it might return 16 for the SSE support it sees and not 64 for the AVX-512 instructions that exist but SDL doesn't know about. Plan accordingly.

Definition at line 773 of file SDL_dynapi_procs.h.

References SDL_assert, SDL_GetCPUFeatures(), and SDL_SIMDAlignment.

Referenced by SDL_SIMDAlloc().

CPU_HAS_SSE
#define CPU_HAS_SSE
Definition: SDL_cpuinfo.c:90
NULL
#define NULL
Definition: begin_code.h:167
CPU_HAS_AVX2
#define CPU_HAS_AVX2
Definition: SDL_cpuinfo.c:96
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:679
CPU_HAS_SSE42
#define CPU_HAS_SSE42
Definition: SDL_cpuinfo.c:94
len
GLenum GLsizei len
Definition: SDL_opengl_glext.h:2926
retval
SDL_bool retval
Definition: testgamecontroller.c:65
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
CPU_HAS_RDTSC
#define CPU_HAS_RDTSC
Definition: SDL_cpuinfo.c:86
CPU_HAS_AVX512F
#define CPU_HAS_AVX512F
Definition: SDL_cpuinfo.c:98
SDL_SIMDGetAlignment
size_t SDL_SIMDGetAlignment(void)
Report the alignment this system needs for SIMD allocations.
Definition: SDL_cpuinfo.c:813
CPU_HAS_MMX
#define CPU_HAS_MMX
Definition: SDL_cpuinfo.c:88
size
GLsizeiptr size
Definition: SDL_opengl_glext.h:537
CPU_HAS_SSE3
#define CPU_HAS_SSE3
Definition: SDL_cpuinfo.c:92
size_t
unsigned int size_t
Definition: SDL_config_windows.h:68
SDL_malloc
#define SDL_malloc
Definition: SDL_dynapi_overrides.h:374
SDL_CPUCount
static int SDL_CPUCount
Definition: SDL_cpuinfo.c:444
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:179